window.Gleam.initSearch([{"doc":"gleam_time","title":"gleam_time","content":"# Time 🕰️\n\nWork with time in Gleam!\n\n[![Package Version](https://img.shields.io/hexpm/v/gleam_time)](https://hex.pm/packages/gleam_time)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gleam_time/)\n\n```sh\ngleam add gleam_time\n```\n\nWorking with time can be difficult so be sure to read the documentation,\nstaring with the [`gleam/time/timestamp`][timestamp] module.\n\n[timestamp]: https://hexdocs.pm/gleam_time/gleam/time/timestamp.html\n","url":"index.html"},{"doc":"gleam/time/duration","title":"Duration","content":"pub opaque type Duration\n An amount of time, with up to nanosecond precision.\n\n This type does not represent calendar periods such as &quot;1 month&quot; or &quot;2\n days&quot;. Those periods will be different lengths of time depending on which\n month or day they apply to. For example, January is longer than February.\n A different type should be used for calendar periods.\n\n\nSynonyms:\ngleam/time/duration.Duration\ngleam/time/duration Duration","url":"gleam/time/duration.html#Duration"},{"doc":"gleam/time/duration","title":"add","content":"pub fn add(left: Duration, right: Duration) -&gt; Duration\n Add two durations together.\n\n # Examples\n\n \n add(seconds(1), seconds(5))\n // -&gt; seconds(6)\n \n\nSynonyms:\ngleam/time/duration.add\ngleam/time/duration add","url":"gleam/time/duration.html#add"},{"doc":"gleam/time/duration","title":"compare","content":"pub fn compare(left: Duration, right: Duration) -&gt; Order\n Compare one duration to another, indicating whether the first spans a\n larger amount of time (and so is greater) or smaller amount of time (and so\n is lesser) than the second.\n\n # Examples\n\n \n compare(seconds(1), seconds(2))\n // -&gt; order.Lt\n \n\n Whether a duration is negative or positive doesn&#39;t matter for comparing\n them, only the amount of time spanned matters.\n\n \n compare(seconds(-2), seconds(1))\n // -&gt; order.Gt\n \n\nSynonyms:\ngleam/time/duration.compare\ngleam/time/duration compare","url":"gleam/time/duration.html#compare"},{"doc":"gleam/time/duration","title":"difference","content":"pub fn difference(left: Duration, right: Duration) -&gt; Duration\n Calculate the difference between two durations.\n\n This is effectively substracting the first duration from the second.\n\n # Examples\n\n \n difference(seconds(1), seconds(5))\n // -&gt; seconds(4)\n \n\nSynonyms:\ngleam/time/duration.difference\ngleam/time/duration difference","url":"gleam/time/duration.html#difference"},{"doc":"gleam/time/duration","title":"milliseconds","content":"pub fn milliseconds(amount: Int) -&gt; Duration\n Create a duration of a number of milliseconds.\nSynonyms:\ngleam/time/duration.milliseconds\ngleam/time/duration milliseconds","url":"gleam/time/duration.html#milliseconds"},{"doc":"gleam/time/duration","title":"nanoseconds","content":"pub fn nanoseconds(amount: Int) -&gt; Duration\n Create a duration of a number of nanoseconds.\n\n # JavaScript int limitations\n\n Remember that JavaScript can only perfectly represent ints between positive\n and negative 9,007,199,254,740,991! If you use a single call to this\n function to create durations larger than that number of nanoseconds then\n you will likely not get exactly the value you expect. Use `seconds` and\n `milliseconds` as much as possible for large durations.\n\nSynonyms:\ngleam/time/duration.nanoseconds\ngleam/time/duration nanoseconds","url":"gleam/time/duration.html#nanoseconds"},{"doc":"gleam/time/duration","title":"seconds","content":"pub fn seconds(amount: Int) -&gt; Duration\n Create a duration of a number of seconds.\nSynonyms:\ngleam/time/duration.seconds\ngleam/time/duration seconds","url":"gleam/time/duration.html#seconds"},{"doc":"gleam/time/duration","title":"to_iso8601_string","content":"pub fn to_iso8601_string(duration: Duration) -&gt; String\n Convert the duration to an [ISO8601][1] formatted duration string.\n\n The ISO8601 duration format is ambiguous without context due to months and\n years having different lengths, and because of leap seconds. This function\n encodes the duration as days, hours, and seconds without any leap seconds.\n Be sure to take this into account when using the duration strings.\n\n [1]: https://en.wikipedia.org/wiki/ISO_8601#Durations\n\nSynonyms:\ngleam/time/duration.to_iso8601_string\ngleam/time/duration to_iso8601_string","url":"gleam/time/duration.html#to_iso8601_string"},{"doc":"gleam/time/duration","title":"to_seconds","content":"pub fn to_seconds(duration: Duration) -&gt; Float\n Convert the duration to a number of seconds.\n\n There may be some small loss of precision due to `Duration` being\n nanosecond accurate and `Float` not being able to represent this.\n\nSynonyms:\ngleam/time/duration.to_seconds\ngleam/time/duration to_seconds","url":"gleam/time/duration.html#to_seconds"},{"doc":"gleam/time/duration","title":"to_seconds_and_nanoseconds","content":"pub fn to_seconds_and_nanoseconds(\n  duration: Duration,\n) -&gt; #(Int, Int)\n Convert the duration to a number of seconds and nanoseconds. There is no\n loss of precision with this conversion on any target.\n\nSynonyms:\ngleam/time/duration.to_seconds_and_nanoseconds\ngleam/time/duration to_seconds_and_nanoseconds","url":"gleam/time/duration.html#to_seconds_and_nanoseconds"},{"doc":"gleam/time/duration","title":"gleam/time/duration","content":"","url":"gleam/time/duration.html"},{"doc":"gleam/time/calendar","title":"Date","content":"pub type Date {\n  Date(year: Int, month: Month, day: Int)\n}\n The Gregorian calendar date. Ambiguous without a time zone.\n\n Prefer to represent your time using the `Timestamp` type, and convert it\n only to calendar types when you need to display them. See the documentation\n for this module for more information.\n\nDate(year: Int, month: Month, day: Int)\n\n\nSynonyms:\ngleam/time/calendar.Date\ngleam/time/calendar Date","url":"gleam/time/calendar.html#Date"},{"doc":"gleam/time/calendar","title":"Month","content":"pub type Month {\n  January\n  February\n  March\n  April\n  May\n  June\n  July\n  August\n  September\n  October\n  November\n  December\n}\n The 12 months of the year.\nJanuary\n\n\nFebruary\n\n\nMarch\n\n\nApril\n\n\nMay\n\n\nJune\n\n\nJuly\n\n\nAugust\n\n\nSeptember\n\n\nOctober\n\n\nNovember\n\n\nDecember\n\n\nSynonyms:\ngleam/time/calendar.Month\ngleam/time/calendar Month","url":"gleam/time/calendar.html#Month"},{"doc":"gleam/time/calendar","title":"TimeOfDay","content":"pub type TimeOfDay {\n  TimeOfDay(\n    hours: Int,\n    minutes: Int,\n    seconds: Int,\n    nanoseconds: Int,\n  )\n}\n The time of day. Ambiguous without a date and time zone. \n\nTimeOfDay(\n  hours: Int,\n  minutes: Int,\n  seconds: Int,\n  nanoseconds: Int,\n)\n\n\nSynonyms:\ngleam/time/calendar.TimeOfDay\ngleam/time/calendar TimeOfDay","url":"gleam/time/calendar.html#TimeOfDay"},{"doc":"gleam/time/calendar","title":"utc_offset","content":"pub const utc_offset: Duration\n The offset for the [Coordinated Universal Time (UTC)](https://en.wikipedia.org/wiki/Coordinated_Universal_Time)\n time zone.\n\n The utc zone has no time adjustments, it is always zero. It never observes\n daylight-saving time and it never shifts around based on political\n restructuring.\n\nSynonyms:\ngleam/time/calendar.utc_offset\ngleam/time/calendar utc_offset","url":"gleam/time/calendar.html#utc_offset"},{"doc":"gleam/time/calendar","title":"local_offset","content":"pub fn local_offset() -&gt; Duration\n Get the offset for the computer&#39;s currently configured time zone.\n\n Note this may not be the time zone that is correct to use for your user.\n For example, if you are making a web application that runs on a server you\n want _their_ computer&#39;s time zone, not yours.\n\nSynonyms:\ngleam/time/calendar.local_offset\ngleam/time/calendar local_offset","url":"gleam/time/calendar.html#local_offset"},{"doc":"gleam/time/calendar","title":"gleam/time/calendar","content":" This module is for working with the Gregorian calendar, established by\n Pope Gregory XIII in 1582!\n\n ## When should you use this module?\n\n The types in this module type are useful when you want to communicate time\n to a human reader, but they are not ideal for computers to work with.\n Disadvantages of calendar time types include:\n\n - They are ambiguous if you don&#39;t know what time-zone they are for.\n - The type permits invalid states. e.g. `days` could be set to the number\n   32, but this should not be possible!\n - There is not a single unique canonical value for each point in time,\n   thanks to time zones. Two different `Date` + `TimeOfDay` value pairs\n   could represent the same point in time. This means that you can&#39;t check\n   for time equality with `==` when using calendar types.\n\n Prefer to represent your time using the `Timestamp` type, and convert it\n only to calendar types when you need to display them.\n\n ## Time zone offsets\n\n This package includes the `utc_offset` value and the `local_offset`\n function, which are the offset for the UTC time zone and get the time\n offset the computer running the program is configured to respectively.\n\n If you need to use other offsets in your program then you will need to get\n them from somewhere else, such as from a package which loads the\n [IANA Time Zone Database](https://www.iana.org/time-zones), or from the\n website visitor&#39;s web browser, which your frontend can send for you.\n\n ## Use in APIs\n\n If you are making an API such as a HTTP JSON API you are encouraged to use\n Unix timestamps instead of calendar times.","url":"gleam/time/calendar.html"},{"doc":"gleam/time/timestamp","title":"Timestamp","content":"pub opaque type Timestamp\n The main time type, which you should favour over other types such as\n calendar time types. It is efficient, unambiguous, and it is not possible\n to construct an invalid timestamp.\n\n The most common situation in which you may need a different time data\n structure is when you need to display time to human for them to read. When\n you need to do this convert the timestamp to calendar time when presenting\n it, but internally always keep the time as a timestamp.\n\n\nSynonyms:\ngleam/time/timestamp.Timestamp\ngleam/time/timestamp Timestamp","url":"gleam/time/timestamp.html#Timestamp"},{"doc":"gleam/time/timestamp","title":"add","content":"pub fn add(timestamp: Timestamp, duration: Duration) -&gt; Timestamp\n Add a duration to a timestamp.\n\n # Examples\n\n \n add(from_unix_seconds(1000), duration.seconds(5))\n // -&gt; from_unix_seconds(1005)\n \n\nSynonyms:\ngleam/time/timestamp.add\ngleam/time/timestamp add","url":"gleam/time/timestamp.html#add"},{"doc":"gleam/time/timestamp","title":"compare","content":"pub fn compare(left: Timestamp, right: Timestamp) -&gt; Order\n Compare one timestamp to another, indicating whether the first is further\n into the future (greater) or further into the past (lesser) than the\n second.\n\n # Examples\n\n \n compare(from_unix_seconds(1), from_unix_seconds(2))\n // -&gt; order.Lt\n \n\nSynonyms:\ngleam/time/timestamp.compare\ngleam/time/timestamp compare","url":"gleam/time/timestamp.html#compare"},{"doc":"gleam/time/timestamp","title":"difference","content":"pub fn difference(left: Timestamp, right: Timestamp) -&gt; Duration\n Calculate the difference between two timestamps.\n\n This is effectively substracting the first timestamp from the second.\n\n # Examples\n\n \n difference(from_unix_seconds(1), from_unix_seconds(5))\n // -&gt; duration.seconds(4)\n \n\nSynonyms:\ngleam/time/timestamp.difference\ngleam/time/timestamp difference","url":"gleam/time/timestamp.html#difference"},{"doc":"gleam/time/timestamp","title":"from_calendar","content":"pub fn from_calendar(\n  date date: Date,\n  time time: TimeOfDay,\n  offset offset: Duration,\n) -&gt; Timestamp\n Create a `Timestamp` from a human-readable calendar time.\n\n # Examples\n\n \n timestamp.from_calendar(\n   date: calendar.Date(2024, calendar.December, 25),\n   time: calendar.TimeOfDay(12, 30, 50, 0),\n   offset: calendar.utc_offset,\n )\n |&gt; timestamp.to_rfc3339(calendar.utc_offset)\n // -&gt; &quot;2024-12-25T12:30:50Z&quot;\n \n\nSynonyms:\ngleam/time/timestamp.from_calendar\ngleam/time/timestamp from_calendar","url":"gleam/time/timestamp.html#from_calendar"},{"doc":"gleam/time/timestamp","title":"from_unix_seconds","content":"pub fn from_unix_seconds(seconds: Int) -&gt; Timestamp\n Create a timestamp from a number of seconds since 00:00:00 UTC on 1 January\n 1970.\n\nSynonyms:\ngleam/time/timestamp.from_unix_seconds\ngleam/time/timestamp from_unix_seconds","url":"gleam/time/timestamp.html#from_unix_seconds"},{"doc":"gleam/time/timestamp","title":"from_unix_seconds_and_nanoseconds","content":"pub fn from_unix_seconds_and_nanoseconds(\n  seconds seconds: Int,\n  nanoseconds nanoseconds: Int,\n) -&gt; Timestamp\n Create a timestamp from a number of seconds and nanoseconds since 00:00:00\n UTC on 1 January 1970.\n\n # JavaScript int limitations\n\n Remember that JavaScript can only perfectly represent ints between positive\n and negative 9,007,199,254,740,991! If you only use the nanosecond field\n then you will almost certainly not get the date value you want due to this\n loss of precision. Always use seconds primarily and then use nanoseconds\n for the final sub-second adjustment.\n\nSynonyms:\ngleam/time/timestamp.from_unix_seconds_and_nanoseconds\ngleam/time/timestamp from_unix_seconds_and_nanoseconds","url":"gleam/time/timestamp.html#from_unix_seconds_and_nanoseconds"},{"doc":"gleam/time/timestamp","title":"parse_rfc3339","content":"pub fn parse_rfc3339(input: String) -&gt; Result(Timestamp, Nil)\n Parses an [RFC 3339 formatted time string][spec] into a `Timestamp`.\n\n [spec]: https://datatracker.ietf.org/doc/html/rfc3339#section-5.6\n \n # Examples\n\n \n let assert Ok(ts) = timestamp.parse_rfc3339(&quot;1970-01-01T00:00:01Z&quot;)\n timestamp.to_unix_seconds_and_nanoseconds(ts)\n // -&gt; #(1, 0)\n \n \n Parsing an invalid timestamp returns an error.\n \n \n let assert Error(Nil) = timestamp.parse_rfc3339(&quot;1995-10-31&quot;)\n \n\n # Notes\n \n - Follows the grammar specified in section 5.6 Internet Date/Time Format of \n   RFC 3339 &lt;https://datatracker.ietf.org/doc/html/rfc3339#section-5.6&gt;.\n - The `T` and `Z` characters may alternatively be lower case `t` or `z`, \n   respectively.\n - Full dates and full times must be separated by `T` or `t`, not any other \n   character such as a space (` `).\n - Leap seconds rules are not considered.  That is, any timestamp may \n   specify digts `00` - `60` for the seconds.\n - Any part of a fractional second that cannot be represented in the \n   nanosecond precision is tructated.  That is, for the time string, \n   `&quot;1970-01-01T00:00:00.1234567899Z&quot;`, the fractional second `.1234567899` \n   will be represented as `123_456_789` in the `Timestamp`.\n \nSynonyms:\ngleam/time/timestamp.parse_rfc3339\ngleam/time/timestamp parse_rfc3339","url":"gleam/time/timestamp.html#parse_rfc3339"},{"doc":"gleam/time/timestamp","title":"system_time","content":"pub fn system_time() -&gt; Timestamp\n Get the current system time.\n\n Note this time is not unique or monotonic, it could change at any time or\n even go backwards! The exact behaviour will depend on the runtime used. See\n the module documentation for more information.\n\n On Erlang this uses [`erlang:system_time/1`][1]. On JavaScript this uses\n [`Date.now`][2].\n\n [1]: https://www.erlang.org/doc/apps/erts/erlang#system_time/1\n [2]: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/now\n\nSynonyms:\ngleam/time/timestamp.system_time\ngleam/time/timestamp system_time","url":"gleam/time/timestamp.html#system_time"},{"doc":"gleam/time/timestamp","title":"to_calendar","content":"pub fn to_calendar(\n  timestamp: Timestamp,\n  offset: Duration,\n) -&gt; #(Date, TimeOfDay)\n Convert a `Timestamp` to calendar time, suitable for presenting to a human\n to read.\n\n If you want a machine to use the time value then you should not use this\n function and should instead keep it as a timestamp. See the documentation\n for the `gleam/time/calendar` module for more information.\n\n # Examples\n\n \n timestamp.from_unix_seconds(0)\n |&gt; timestamp.to_calendar(calendar.utc_offset)\n // -&gt; #(Date(1970, January, 1), TimeOfDay(0, 0, 0, 0))\n \n\nSynonyms:\ngleam/time/timestamp.to_calendar\ngleam/time/timestamp to_calendar","url":"gleam/time/timestamp.html#to_calendar"},{"doc":"gleam/time/timestamp","title":"to_rfc3339","content":"pub fn to_rfc3339(\n  timestamp: Timestamp,\n  offset: Duration,\n) -&gt; String\n Convert a timestamp to a RFC 3339 formatted time string, with an offset\n supplied as an additional argument.\n\n The output of this function is also ISO 8601 compatible so long as the\n offset not negative. Offsets have at-most minute precision, so an offset\n with higher precision will be rounded to the nearest minute.\n\n If you are making an API such as a HTTP JSON API you are encouraged to use\n Unix timestamps instead of this format or ISO 8601. Unix timestamps are a\n better choice as they don&#39;t contain offset information. Consider:\n\n - UTC offsets are not time zones. This does not and cannot tell us the time\n   zone in which the date was recorded. So what are we supposed to do with\n   this information?\n - Users typically want dates formatted according to their local time zone.\n   What if the provided UTC offset is different from the current user&#39;s time\n   zone? What are we supposed to do with it then?\n - Despite it being useless (or worse, a source of bugs), the UTC offset\n   creates a larger payload to transfer.\n\n They also uses more memory than a unix timestamp. The way they are better\n than Unix timestamp is that it is easier for a human to read them, but\n this is a hinderance that tooling can remedy, and APIs are not primarily\n for humans.\n\n # Examples\n\n \n to_rfc3339(from_unix_seconds(1000), 0)\n // -&gt; &quot;1970-01-01T00:00:00Z&quot;\n \n\nSynonyms:\ngleam/time/timestamp.to_rfc3339\ngleam/time/timestamp to_rfc3339","url":"gleam/time/timestamp.html#to_rfc3339"},{"doc":"gleam/time/timestamp","title":"to_unix_seconds","content":"pub fn to_unix_seconds(timestamp: Timestamp) -&gt; Float\n Convert the timestamp to a number of seconds since 00:00:00 UTC on 1\n January 1970.\n\n There may be some small loss of precision due to `Timestamp` being\n nanosecond accurate and `Float` not being able to represent this.\n\nSynonyms:\ngleam/time/timestamp.to_unix_seconds\ngleam/time/timestamp to_unix_seconds","url":"gleam/time/timestamp.html#to_unix_seconds"},{"doc":"gleam/time/timestamp","title":"to_unix_seconds_and_nanoseconds","content":"pub fn to_unix_seconds_and_nanoseconds(\n  timestamp: Timestamp,\n) -&gt; #(Int, Int)\n Convert the timestamp to a number of seconds and nanoseconds since 00:00:00\n UTC on 1 January 1970. There is no loss of precision with this conversion\n on any target.\nSynonyms:\ngleam/time/timestamp.to_unix_seconds_and_nanoseconds\ngleam/time/timestamp to_unix_seconds_and_nanoseconds","url":"gleam/time/timestamp.html#to_unix_seconds_and_nanoseconds"},{"doc":"gleam/time/timestamp","title":"gleam/time/timestamp","content":" Welcome to the timestamp module! This module and its `Timestamp` type are\n what you will be using most commonly when working with time in Gleam.\n\n A timestamp represents a moment in time, represented as an amount of time\n since the calendar time 00:00:00 UTC on 1 January 1970, also known as the\n _Unix epoch_.\n\n # Wall clock time and monotonicity\n\n Time is very complicated, especially on computers! While they generally do\n a good job of keeping track of what the time is, computers can get\n out-of-sync and start to report a time that is too late or too early. Most\n computers use &quot;network time protocol&quot; to tell each other what they think\n the time is, and computers that realise they are running too fast or too\n slow will adjust their clock to correct it. When this happens it can seem\n to your program that the current time has changed, and it may have even\n jumped backwards in time!\n\n This measure of time is called _wall clock time_, and it is what people\n commonly think of when they think of time. It is important to be aware that\n it can go backwards, and your program must not rely on it only ever going\n forwards at a steady rate. For example, for tracking what order events happen\n in. \n\n This module uses wall clock time. If your program needs time values to always\n increase you will need a _monotonic_ time instead. It&#39;s uncommon that you\n would need monotonic time, one example might be if you&#39;re making a\n benchmarking framework.\n\n The exact way that time works will depend on what runtime you use. The\n Erlang documentation on time has a lot of detail about time generally as well\n as how it works on the BEAM, it is worth reading.\n &lt;https://www.erlang.org/doc/apps/erts/time_correction&gt;.\n\n # Converting to local time\n\n Timestamps don&#39;t take into account time zones, so a moment in time will\n have the same timestamp value regardless of where you are in the world. To\n convert them to local time you will need to know the offset for the time\n zone you wish to use, likely from a time zone database. See the\n `gleam/time/calendar` module for more information.\n","url":"gleam/time/timestamp.html"}]);